Extra Characters in a String - Top-down and Bottom-up DP
Array C++ Dynamic Programming Hash Table Medium Memoization Recursion String Trie
Problem Statement:
You are given a 0-indexed string s
and a dictionary of words dictionary
. You have to break s
into one or more non-overlapping substrings such that each substring is present in dictionary
. There may be some extra characters in s
which are not present in any of the substrings.
Return the minimum number of extra characters left over if you break up s
optimally.
Example 1:
Input: s = "leetscode", dictionary = ["leet","code","leetcode"] Output: 1 Explanation: We can break s in two substrings: "leet" from index 0 to 3 and "code" from index 5 to 8. There is only 1 unused character (at index 4), so we return 1.
Example 2:
Input: s = "sayhelloworld", dictionary = ["hello","world"] Output: 3 Explanation: We can break s in two substrings: "hello" from index 3 to 7 and "world" from index 8 to 12. The characters at indices 0, 1, 2 are not used in any substring and thus are considered as extra characters. Hence, we return 3.
Constraints:
1 <= s.length <= 50
1 <= dictionary.length <= 50
1 <= dictionary[i].length <= 50
dictionary[i]
ands
consists of only lowercase English lettersdictionary
contains distinct words
Solution:
Let us think through a basic solution. Here is the logic:
- The largest possible answer is length of string. This is the case where we just add 1 for all values till we reach end.
1+dfs(s,index+1)
denotes that we have skipped current index and looking for answer starting from next index.- We have a chance of getting lower value if we check set membership for each substring starting from current index. This is the basic idea.
I will provide 3 solutions using above logic. I have kept the variable names same to ease understanding things better.
Naive recursion(TLE)
Recursion with memoization (AC)
Bottom-up DP (AC)